import kotlinx.coroutines.test.runTest
import net.sergeych.crypto2.NumericNonce
import net.sergeych.crypto2.createContrail
import net.sergeych.crypto2.initCrypto
import net.sergeych.crypto2.isValidContrail
import kotlin.test.*

class ToolsTest {
    @Test
    fun testContrails() = runTest {
        initCrypto()
        val c = createContrail(ubyteArrayOf(1u, 2u, 3u, 4u, 5u))
        assertEquals(134u, c[0])
        assertTrue { isValidContrail(c) }
        c[2] = 11u
        assertFalse { isValidContrail(c) }
    }

    @Test
    fun numericNonceTest() = runTest{
        initCrypto()
        val nn = NumericNonce.random(32)
        val counter = 1031
        val x1 = nn.withInt(0)
        val x2 = nn.withInt(counter)
//        println(x1.toDump())
//        println(x2.toDump())
        val t = (x1[0] xor x2[0]).toInt() + ((x1[1] xor x2[1]).toInt() shl 8)
        assertEquals(counter, t)
        assertContentEquals(x1.drop(2), x2.drop(2))
    }
}